<template>
    <div class="container-lg mt-3">
        <h2 class="mb-5">Apply price formula to my products</h2>
        <div class="row mb-5 pt-4" v-for="product,index in  products" v-bind:key="index">
            <div class="col-3 text-center">
                <div class="font22">
                    {{product.title}}
                </div>
                <img :src="product.image" width="220px" height="220px" alt="">
                <div class="font25">
                    Original price
                </div>
                <div class="font30 fw-bold">
                    € {{product.price}}
                </div>
            </div>
            <div class="col-1 d-flex align-items-center">
                <img src="@/assets/arrow_right.png" width="90%" alt="">
            </div>
             <div class="col-4 d-flex align-items-center">
                <div class="border-dashed content-form d-flex align-items-center justify-content-center text-secondary cursor_pointer" @click="onSelectProduct(product)">
                    <div class="text-center font50" v-if="product.formula">
                        {{product.formula.name}}
                    </div>
                    <div v-else class="text-center">
                        <div class="mb-2">
                            <i class="fas fa-plus-circle font50 "></i>
                        </div>
                        <div>
                            <span class="font20">Choose a formula for this product</span>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-1 d-flex align-items-center">
                <img src="@/assets/arrow_right.png" width="90%" alt="">
            </div>
             <div class="col-3 text-center">
                 <div class="font22">
                    {{product.title}}
                </div>
                <img :src="product.image" width="220px" height="220px" alt="">
                <div class="font25">
                    Modified price
                </div>
                <div class="font30 fw-bold">
                    <span v-if="product.formula">
                        € {{product.formula.modified_price}}
                    </span>
                     <span v-else>
                        € {{product.price}}
                    </span>
                </div>
            </div>
        </div>
        <modal v-if="showModal" btnCancelText="Cancelar" size="lg" btnAcceptText="Grabar" title="Apply price formula to my products" @accept="onSavePrice" @close="showModal=false" >
            <div class="row">
                <div class="col-4">
                    <img :src="product.image" width="100%" class="p-3">
                </div>
                <div class="col-8">
                    <div class="font25 fw-bold">
                        {{product.title}}
                    </div>
                     <div class="font16">
                        {{product.description}}
                    </div>
                    <label class="mt-3 font16 fw-bold">
                        Formula:
                    </label>
                    <div>
                        <b-form-select @change="onSelectFormula" v-model="formula_id" value-field="id" text-field="name" size="lg" :options="options"></b-form-select>
                    </div>
                    <div class="mt-3  fw-bold row">
                        <span class="font16 col-6" >
                            Price 
                        </span>
                        <span class="font25 col-6" >
                            € {{product.price}}
                        </span>
                    </div>
                    <div class="mt-1 font16 fw-bold row" v-if="selected_formula">
                        <span class="font16 col-6" >
                            Modified price 
                        </span>
                         <span class="font25 col-6">
                             {{selected_formula.modified_price}}
                         </span>
                    </div>
                    <div v-if="validation_form" class="mt-2 text-danger">
                        you must choose a formula
                    </div>
                </div>
            </div>
        </modal>
    </div>
</template>
<script>
import { apiCallList } from '../mixins'
import modal from '../components/modal.vue'

export default {
    mixins: [apiCallList],
    components: { modal },
    data(){
        return {
            endpoint : "api/products",
            products : [],
            showModal : false,
            product : null,
            formula_id : null,
            options : [],
            selected_formula : null,
            validation_form : false,
        } 
    },
    created(){
        this.onLoadFormulas()
    },
    methods : {
        loadItems (){
            this.products = this.data.products;
        },
        onSelectProduct(product){
            this.validation_form = false;
            this.formula_id = null;
            this.selected_formula = null;
            this.product = product;
            if(product.formula){
                this.formula_id = product.formula.id;
                this.onSelectFormula();
            }

            this.showModal = true;
        },
        onLoadFormulas(){
            this.$axios("/api/formulas")
            .then((response) => {
                this.options = response.data.formulas;
            })
        },  
        onSelectFormula(){
            let formula_id = this.formula_id;
            let formula = this.options.filter((item) => {
                return item.id == formula_id;
            });
            this.selected_formula = formula[0];
            this.selected_formula.modified_price = eval(this.product.price+formula[0].value);
            this.validation_form = false;   
            
        },
        onSavePrice(){
            if(this.formula_id){
                let data = this.product;
                data.formula = this.selected_formula;
                this.$axios.put("/api/products/"+this.product.id, data)
                    .then(() => {
                        this.fetch();
                        this.showModal = false;
                    })
                    .catch(() => {
                    })
            }
            else
                this.validation_form = true;
            
        }

    }
}
</script>
<style >
    .font25{
        font-size: 25px;
    }
    .cursor_pointer{
        cursor: pointer;
    }
    .font20{
        font-size: 20px;
    }
    .custom-select-lg{
        width: 100%;
    }
    .font30{
        font-size: 30px;
    }
    .font18{
        font-size: 18px;
    }
    .font22{
        font-size: 22px;
    }
    .font16{
        font-size: 16px !important; 
    }
    .border-dashed{
        border: 4px dashed gray;
    }
    .font50{
        font-size: 50px;
    }
    .content-form{
        height: 200px;
        width: 100%;
    }
</style>